Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## igeo
Class IPointR

    java.lang.Object
      igeo.IObject
          igeo.IPointR

All Implemented Interfaces:
  IParameter, ITransformable, IVal, IVecI, IVecOp

    public class IPointR

extends IObject
implements IVecI

Reference class of a point object to contain any instance of IVecI.

Author:
  Satoru Sugihara

Field Summary
`IVecI` | `pos`

Fields inherited from class igeo.IObject
`attribute, dynamics, graphics, parameter, server, userData`

Constructor Summary
`IPointR()`
`IPointR(double x, double y, double z)`
`IPointR(IPointR p)`
`IPointR(IServerI s)`
`IPointR(IServerI s, double x, double y, double z)`
`IPointR(IServerI s, IPointR p)`
`IPointR(IServerI s, IVecI v)`
`IPointR(IVecI v)`

Method Summary
`IPointR` | `add(double x, double y, double z)`
`IPointR` | `add(double f, IVecI v)` scale add alias
`IPointR` | `add(IDoubleI x, IDoubleI y, IDoubleI z)`
`IPointR` | `add(IDoubleI f, IVecI v)` scale add alias
`IPointR` | `add(IVecI v)`
`IPointR` | `add(IVecI v, double f)` scale add
`IPointR` | `add(IVecI v, IDoubleI f)` scale add
`double` | `angle(double vx, double vy, double vz)` get angle between two vector from 0 to Pi
`double` | `angle(double vx, double vy, double vz, double axisX, double axisY, double axisZ)`
`double` | `angle(ISwitchE e, IVecI v)` get angle between two vector from 0 to Pi
`double` | `angle(ISwitchE e, IVecI v, IVecI axis)`
`IDoubleI` | `angle(ISwitchR r, IVecI v)` get angle between two vector from 0 to Pi
`IDoubleI` | `angle(ISwitchR r, IVecI v, IVecI axis)`
`double` | `angle(IVecI v)` get angle between two vector from 0 to Pi
`double` | `angle(IVecI v, IVecI axis)`
`IVecI` | `bisect(double vx, double vy, double vz)` create a new instance of bisector
`IVecI` | `bisect(IVecI v)` create a new instance of bisector
`IVecI` | `center()` center is same with position
`IPointR` | `clr(java.awt.Color c)`
`IPointR` | `clr(java.awt.Color c, double alpha)`
`IPointR` | `clr(java.awt.Color c, float alpha)`
`IPointR` | `clr(java.awt.Color c, int alpha)`
`IPointR` | `clr(double dgray)`
`IPointR` | `clr(double dgray, double dalpha)`
`IPointR` | `clr(double dr, double dg, double db)`
`IPointR` | `clr(double dr, double dg, double db, double da)`
`IPointR` | `clr(float fgray)`
`IPointR` | `clr(float fgray, float falpha)`
`IPointR` | `clr(float fr, float fg, float fb)`
`IPointR` | `clr(float fr, float fg, float fb, float fa)`
`IPointR` | `clr(IColor c)`
`IPointR` | `clr(IColor c, double alpha)` to set color, with alpha value overwritten
`IPointR` | `clr(IColor c, float alpha)` to set color, with alpha value overwritten
`IPointR` | `clr(IColor c, int alpha)` to set color, with alpha value overwritten
`IPointR` | `clr(int gray)`
`IPointR` | `clr(int gray, int alpha)`
`IPointR` | `clr(int r, int g, int b)`
`IPointR` | `clr(int r, int g, int b, int a)`
`IPointR` | `cp()` cp() is alias of dup()
`IPointR` | `cp(double x, double y, double z)` cp() is alias of dup().add()
`IPointR` | `cp(IDoubleI x, IDoubleI y, IDoubleI z)` cp() is alias of dup().add()
`IPointR` | `cp(IVecI v)` cp() is alias of dup().add()
`IGraphicObject` | `createGraphic(IGraphicMode m)`
`IVecI` | `cross(double vx, double vy, double vz)` cross product, creating a new instance
`IVecI` | `cross(IVecI v)` cross product, creating a new instance
`IVecI` | `dif(double vx, double vy, double vz)` create a new instance of difference
`IVecI` | `dif(IVecI v)` create a new instance of difference
`IVecI` | `diff(double vx, double vy, double vz)` alias of dif
`IVecI` | `diff(IVecI v)` alias of dif
`double` | `dist(double vx, double vy, double vz)` distance of two vectors
`double` | `dist(ISwitchE e, IVecI v)` distance of two vectors
`IDoubleI` | `dist(ISwitchR r, IVecI v)` distance of two vectors
`double` | `dist(IVecI v)` distance of two vectors
`double` | `dist2(double vx, double vy, double vz)` squared distance of two vectors
`double` | `dist2(ISwitchE e, IVecI v)` squared distance of two vectors
`IDoubleI` | `dist2(ISwitchR r, IVecI v)` squared distance of two vectors
`double` | `dist2(IVecI v)` squared distance of two vectors
`IPointR` | `div(double v)`
`IPointR` | `div(IDoubleI v)`
`double` | `dot(double vx, double vy, double vz)` dot product
`double` | `dot(ISwitchE e, IVecI v)` dot product
`IDoubleI` | `dot(ISwitchR r, IVecI v)` dot product
`double` | `dot(IVecI v)` dot product
`IPointR` | `dup()` duplicate object
`boolean` | `eq(double vx, double vy, double vz)` check whether location is same or not
`boolean` | `eq(double vx, double vy, double vz, double tolerance)` check whether location is same or not with tolerance
`boolean` | `eq(ISwitchE e, IVecI v)` check whether location is same or not
`boolean` | `eq(ISwitchE e, IVecI v, double tolerance)` check whether location is same or not with tolerance
`IBoolI` | `eq(ISwitchR r, IVecI v)` check whether location is same or not
`IBoolI` | `eq(ISwitchR r, IVecI v, IDoubleI tolerance)` check whether location is same or not with tolerance
`boolean` | `eq(IVecI v)` check whether location is same or not
`boolean` | `eq(IVecI v, double tolerance)` check whether location is same or not with tolerance
`boolean` | `eqX(double vx)` check if same in X
`boolean` | `eqX(double vx, double tolerance)` check if same in X with tolerance
`boolean` | `eqX(ISwitchE e, IVecI v)` check if same in X
`boolean` | `eqX(ISwitchE e, IVecI v, double tolerance)` check if same in X with tolerance
`IBoolI` | `eqX(ISwitchR r, IVecI v)` check if same in X
`IBoolI` | `eqX(ISwitchR r, IVecI v, IDoubleI tolerance)` check if same in X with tolerance
`boolean` | `eqX(IVecI v)` check if same in X
`boolean` | `eqX(IVecI v, double tolerance)` check if same in X with tolerance
`boolean` | `eqY(double vy)` check if same in Y
`boolean` | `eqY(double vy, double tolerance)` check if same in Y with tolerance
`boolean` | `eqY(ISwitchE e, IVecI v)` check if same in Y
`boolean` | `eqY(ISwitchE e, IVecI v, double tolerance)` check if same in Y with tolerance
`IBoolI` | `eqY(ISwitchR r, IVecI v)` check if same in Y
`IBoolI` | `eqY(ISwitchR r, IVecI v, IDoubleI tolerance)` check if same in Y with tolerance
`boolean` | `eqY(IVecI v)` check if same in Y
`boolean` | `eqY(IVecI v, double tolerance)` check if same in Y with tolerance
`boolean` | `eqZ(double vz)` check if same in Z
`boolean` | `eqZ(double vz, double tolerance)` check if same in Z with tolerance
`boolean` | `eqZ(ISwitchE e, IVecI v)` check if same in Z
`boolean` | `eqZ(ISwitchE e, IVecI v, double tolerance)` check if same in Z with tolerance
`IBoolI` | `eqZ(ISwitchR r, IVecI v)` check if same in Z
`IBoolI` | `eqZ(ISwitchR r, IVecI v, IDoubleI tolerance)` check if same in Z with tolerance
`boolean` | `eqZ(IVecI v)` check if same in Z
`boolean` | `eqZ(IVecI v, double tolerance)` check if same in Z with tolerance
`IPointR` | `flip()` alias of neg
`IVec` | `get()`
`double` | `getSize()`
`IDoubleI` | `getX()`
`IDoubleI` | `getY()`
`IDoubleI` | `getZ()`
`IPointR` | `hide()`
`IPointR` | `hsb(double h, double s, double b)`
`IPointR` | `hsb(double h, double s, double b, double a)`
`IPointR` | `hsb(float h, float s, float b)`
`IPointR` | `hsb(float h, float s, float b, float a)`
`protected void` | `initPoint(IServerI s)`
`boolean` | `isValid()` checking x, y, and z is valid number (not Infinite, nor NaN).
`IPointR` | `layer(ILayer l)` Set layer by ILayer object
`double` | `len()` getting length of the vector
`IPointR` | `len(double l)` setting length
`IPointR` | `len(IDoubleI l)` setting length
`double` | `len(ISwitchE e)` getting length of the vector
`IDoubleI` | `len(ISwitchR r)` getting length of the vector
`double` | `len2()` getting squared length of the vector
`double` | `len2(ISwitchE e)` getting squared length of the vector
`IDoubleI` | `len2(ISwitchR r)` getting squared length of the vector
`IVecI` | `mid(double vx, double vy, double vz)` create a new instance of midpoint
`IVecI` | `mid(IVecI v)` create a new instance of midpoint
`IPointR` | `mirror(double planeX, double planeY, double planeZ)` alias of ref
`IPointR` | `mirror(double centerX, double centerY, double centerZ, double planeX, double planeY, double planeZ)` alias of ref
`IPointR` | `mirror(IVecI planeDir)` reflect (mirror) 3 dimensionally to the other side of the plane
`IPointR` | `mirror(IVecI center, IVecI planeDir)` alias of ref
`IPointR` | `mul(double v)`
`IPointR` | `mul(IDoubleI v)`
`IPointR` | `mv(double x, double y, double z)` mv() is alias of add()
`IPointR` | `mv(IDoubleI x, IDoubleI y, IDoubleI z)` mv() is alias of add()
`IPointR` | `mv(IVecI v)` mv() is alias of add()
`IPointR` | `name(java.lang.String nm)`
`IPointR` | `neg()`
`IVecI` | `nml(double vx, double vy, double vz)` alias of cross
`IVecI` | `nml(double vx1, double vy1, double vz1, double vx2, double vy2, double vz2)` create normal vector from 3 points of self, pt1 and pt2
`IVecI` | `nml(IVecI v)` alias of cross.
`IVecI` | `nml(IVecI pt1, IVecI pt2)` create normal vector from 3 points of self, pt1 and pt2
`IVecI` | `pos()` passing position field
`IPointR` | `ref(double planeX, double planeY, double planeZ)` reflect(mirror) 3 dimensionally to the other side of the plane
`IPointR` | `ref(double centerX, double centerY, double centerZ, double planeX, double planeY, double planeZ)` reflect(mirror) 3 dimensionally to the other side of the plane
`IPointR` | `ref(IVecI planeDir)` reflect (mirror) 3 dimensionally to the other side of the plane
`IPointR` | `ref(IVecI center, IVecI planeDir)` reflect(mirror) 3 dimensionally to the other side of the plane
`IPointR` | `rev()` alias of neg()
`IPointR` | `rot(double angle)` rotation on XY plane
`IPointR` | `rot(double axisX, double axisY, double axisZ, double angle)` rotation around axis vector
`IPointR` | `rot(double centerX, double centerY, double centerZ, double axisX, double axisY, double axisZ, double angle)` rotation around axis vector and center point
`IPointR` | `rot(IDoubleI angle)` rotation around z-axis and origin
`IPointR` | `rot(IVecI axis, double angle)` rotation around axis vector
`IPointR` | `rot(IVecI axis, IDoubleI angle)` rotation around axis vector
`IPointR` | `rot(IVecI axis, IVecI destDir)` rotate to destination direction vector
`IPointR` | `rot(IVecI center, IVecI axis, double angle)` rotation around axis vector and center point
`IPointR` | `rot(IVecI center, IVecI axis, IDoubleI angle)` rotation around axis vector and center
`IPointR` | `rot(IVecI center, IVecI axis, IVecI destPt)` rotate to destination point location
`IPointR` | `rot2(double angle)` alias of rot(double)
`IPointR` | `rot2(double centerX, double centerY, double angle)` rotation on xy-plane
`IPointR` | `rot2(IDoubleI angle)` alias of rot(IDoubleI)
`IPointR` | `rot2(IVecI destDir)` rotation on xy-plane to destination direction vector
`IPointR` | `rot2(IVecI center, double angle)` rotation on xy-plane
`IPointR` | `rot2(IVecI center, IDoubleI angle)` rotation on xy-plane around center
`IPointR` | `rot2(IVecI center, IVecI destPt)` rotation on xy-plane to destination point location
`IPointR` | `scale(double f)` alias of mul
`IPointR` | `scale(double centerX, double centerY, double centerZ, double f)` scale from a center
`IPointR` | `scale(IDoubleI f)` alias of mul
`IPointR` | `scale(IVecI center, double f)` scale from a center
`IPointR` | `scale(IVecI center, IDoubleI f)` scale from a center
`IPointR` | `scale1d(double axisX, double axisY, double axisZ, double f)` scale only in 1 direction
`IPointR` | `scale1d(double centerX, double centerY, double centerZ, double axisX, double axisY, double axisZ, double f)` scale only in 1 direction from a center
`IPointR` | `scale1d(IVecI axis, double f)` scale only in 1 direction
`IPointR` | `scale1d(IVecI axis, IDoubleI f)` scale only in 1 direction
`IPointR` | `scale1d(IVecI center, IVecI axis, double f)` scale only in 1 direction from a center
`IPointR` | `scale1d(IVecI center, IVecI axis, IDoubleI f)` scale only in 1 direction from a center
`IPointR` | `set(double x, double y, double z)`
`IPointR` | `set(IDoubleI x, IDoubleI y, IDoubleI z)`
`IPointR` | `set(IVecI v)`
`IPointR` | `setColor(java.awt.Color c)`
`IPointR` | `setColor(java.awt.Color c, int alpha)`
`IPointR` | `setColor(double dgray)`
`IPointR` | `setColor(double dgray, double dalpha)`
`IPointR` | `setColor(double dr, double dg, double db)`
`IPointR` | `setColor(double dr, double dg, double db, double da)`
`IPointR` | `setColor(float fgray)`
`IPointR` | `setColor(float fgray, float falpha)`
`IPointR` | `setColor(float fr, float fg, float fb)`
`IPointR` | `setColor(float fr, float fg, float fb, float fa)`
`IPointR` | `setColor(int gray)`
`IPointR` | `setColor(int gray, int alpha)`
`IPointR` | `setColor(int r, int g, int b)`
`IPointR` | `setColor(int r, int g, int b, int a)`
`IPointR` | `setHSBColor(double h, double s, double b)`
`IPointR` | `setHSBColor(double h, double s, double b, double a)`
`IPointR` | `setHSBColor(float h, float s, float b)`
`IPointR` | `setHSBColor(float h, float s, float b, float a)`
`IPointR` | `setSize(double sz)` set size of dot in graphic
`IPointR` | `shear(double sxy, double syx, double syz, double szy, double szx, double sxz)` shear operation
`IPointR` | `shear(IDoubleI sxy, IDoubleI syx, IDoubleI syz, IDoubleI szy, IDoubleI szx, IDoubleI sxz)` shear operation
`IPointR` | `shear(IVecI center, double sxy, double syx, double syz, double szy, double szx, double sxz)` shear operation
`IPointR` | `shear(IVecI center, IDoubleI sxy, IDoubleI syx, IDoubleI syz, IDoubleI szy, IDoubleI szx, IDoubleI sxz)` shear operation
`IPointR` | `shearXY(double sxy, double syx)` shear operation on XY
`IPointR` | `shearXY(IDoubleI sxy, IDoubleI syx)` shear operation on XY
`IPointR` | `shearXY(IVecI center, double sxy, double syx)` shear operation on XY
`IPointR` | `shearXY(IVecI center, IDoubleI sxy, IDoubleI syx)` shear operation on XY
`IPointR` | `shearYZ(double syz, double szy)` shear operation on YZ
`IPointR` | `shearYZ(IDoubleI syz, IDoubleI szy)` shear operation on YZ
`IPointR` | `shearYZ(IVecI center, double syz, double szy)` shear operation on YZ
`IPointR` | `shearYZ(IVecI center, IDoubleI syz, IDoubleI szy)` shear operation on YZ
`IPointR` | `shearZX(double szx, double sxz)` shear operation on ZX
`IPointR` | `shearZX(IDoubleI szx, IDoubleI sxz)` shear operation on ZX
`IPointR` | `shearZX(IVecI center, double szx, double sxz)` shear operation on ZX
`IPointR` | `shearZX(IVecI center, IDoubleI szx, IDoubleI sxz)` shear operation on ZX
`IPointR` | `show()`
`double` | `size()`
`IPointR` | `size(double sz)`
`IPointR` | `sub(double x, double y, double z)`
`IPointR` | `sub(IDoubleI x, IDoubleI y, IDoubleI z)`
`IPointR` | `sub(IVecI v)`
`IVecI` | `sum(double vx, double vy, double vz)` create a new instance of total summation
`IVecI` | `sum(IVecI... v)` create a new instance of total summation
`IVecI` | `sum(IVecI v)` create a new instance of total summation
`IVecI` | `sum(IVecI v2, double w2)` create a new instance of weighted sum
`IVecI` | `sum(IVecI v2, double w1, double w2)` weighted sum.
`IVecI` | `sum(IVecI v2, IDoubleI w2)` create a new instance of weighted sum
`IVecI` | `sum(IVecI v2, IDoubleI w1, IDoubleI w2)` create a new instance of weighted sum
`IVec2I` | `to2d()`
`IVec2I` | `to2d(IVecI projectionDir)`
`IVec2I` | `to2d(IVecI xaxis, IVecI yaxis)`
`IVec2I` | `to2d(IVecI xaxis, IVecI yaxis, IVecI origin)`
`IVec4I` | `to4d()`
`IVec4I` | `to4d(double w)`
`IVec4I` | `to4d(IDoubleI w)`
`IPointR` | `transform(IMatrix3I mat)` transform with a transformation matrix
`IPointR` | `transform(IMatrix4I mat)` transform with a transformation matrix
`IPointR` | `transform(IVecI xvec, IVecI yvec, IVecI zvec)` transform with a transformation vectors
`IPointR` | `transform(IVecI xvec, IVecI yvec, IVecI zvec, IVecI translate)` transform with a transformation vectors
`IPointR` | `translate(double x, double y, double z)` translate is alias of add()
`IPointR` | `translate(IDoubleI x, IDoubleI y, IDoubleI z)` alias of add()
`IPointR` | `translate(IVecI v)` alias of add()
`IPointR` | `unit()` unitize
`IPointR` | `weight(double w)`
`IPointR` | `weight(float w)`
`double` | `x()` getting x component
`IPointR` | `x(double vx)` setting x component
`IPointR` | `x(IDoubleI vx)` setting x component
`double` | `x(ISwitchE e)` getting x component
`IDoubleI` | `x(ISwitchR r)` getting x component
`double` | `y()` getting y component
`IPointR` | `y(double vy)` setting y component
`IPointR` | `y(IDoubleI vy)` setting y component
`double` | `y(ISwitchE e)` getting y component
`IDoubleI` | `y(ISwitchR r)` getting y component
`double` | `z()` getting z component
`IPointR` | `z(double vz)` setting z component
`IPointR` | `z(IDoubleI vz)` setting z component
`double` | `z(ISwitchE e)` getting z component
`IDoubleI` | `z(ISwitchR r)` getting z component
`IPointR` | `zero()` setting all zero

Methods inherited from class igeo.IObject
`addDynamics, alpha, alphaInt, attr, attr, attr, awtColor, blue, blueInt, clearDynamics, clearGraphics, clr, defaultAttribute, del, deletDynamics, deleteDynamics, deleteDynamics, deleteGraphic, dynamicsNum, getAWTColor, getColor, getDynamics, getGraphic, getGraphic, getParameter, graphicsNum, gray, grayInt, green, greenInt, greyInt, initGraphic, initObject, isVisible, layer, layer, name, red, redInt, resetGraphic, server, setColor, setColor, setColor, setColor, setColor, setColor, setParameter, syncColor, syncGraphic, syncVisibility, syncWeight, updateGraphic, userData, userData, visible, weight`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### pos

    public IVecI pos

Constructor Detail

### IPointR

    public IPointR()

### IPointR

    public IPointR(IVecI v)

### IPointR

    public IPointR(double x,
                   double y,
                   double z)

### IPointR

    public IPointR(IServerI s)

### IPointR

    public IPointR(IServerI s,
                   IVecI v)

### IPointR

    public IPointR(IServerI s,
                   double x,
                   double y,
                   double z)

### IPointR

    public IPointR(IPointR p)

### IPointR

    public IPointR(IServerI s,
                   IPointR p)

Method Detail

### initPoint

    protected void initPoint(IServerI s)

### createGraphic

    public IGraphicObject createGraphic(IGraphicMode m)

  Overrides:
    `createGraphic` in class `IObject`

### x

    public double x()

  Description copied from interface: `IVecI`
  getting x component

  Specified by:
    `x` in interface `IVecI`

### y

    public double y()

  Description copied from interface: `IVecI`
  getting y component

  Specified by:
    `y` in interface `IVecI`

### z

    public double z()

  Description copied from interface: `IVecI`
  getting z component

  Specified by:
    `z` in interface `IVecI`

### x

    public IPointR x(double vx)

  Description copied from interface: `IVecI`
  setting x component

  Specified by:
    `x` in interface `IVecI`

### y

    public IPointR y(double vy)

  Description copied from interface: `IVecI`
  setting y component

  Specified by:
    `y` in interface `IVecI`

### z

    public IPointR z(double vz)

  Description copied from interface: `IVecI`
  setting z component

  Specified by:
    `z` in interface `IVecI`

### x

    public IPointR x(IDoubleI vx)

  Description copied from interface: `IVecI`
  setting x component

  Specified by:
    `x` in interface `IVecI`

### y

    public IPointR y(IDoubleI vy)

  Description copied from interface: `IVecI`
  setting y component

  Specified by:
    `y` in interface `IVecI`

### z

    public IPointR z(IDoubleI vz)

  Description copied from interface: `IVecI`
  setting z component

  Specified by:
    `z` in interface `IVecI`

### x

    public double x(ISwitchE e)

  Description copied from interface: `IVecI`
  getting x component

  Specified by:
    `x` in interface `IVecI`

### y

    public double y(ISwitchE e)

  Description copied from interface: `IVecI`
  getting y component

  Specified by:
    `y` in interface `IVecI`

### z

    public double z(ISwitchE e)

  Description copied from interface: `IVecI`
  getting z component

  Specified by:
    `z` in interface `IVecI`

### x

    public IDoubleI x(ISwitchR r)

  Description copied from interface: `IVecI`
  getting x component

  Specified by:
    `x` in interface `IVecI`

### y

    public IDoubleI y(ISwitchR r)

  Description copied from interface: `IVecI`
  getting y component

  Specified by:
    `y` in interface `IVecI`

### z

    public IDoubleI z(ISwitchR r)

  Description copied from interface: `IVecI`
  getting z component

  Specified by:
    `z` in interface `IVecI`

### get

    public IVec get()

  Specified by:
    `get` in interface `IParameter`
  Specified by:
    `get` in interface `IVecI`
  Specified by:
    `get` in interface `IVecOp`

### pos

    public IVecI pos()

  passing position field

### center

    public IVecI center()

  center is same with position

### dup

    public IPointR dup()

  Description copied from class: `IObject`
  duplicate object

  Specified by:
    `dup` in interface `ITransformable`
  Specified by:
    `dup` in interface `IVecI`
  Overrides:
    `dup` in class `IObject`

### to2d

    public IVec2I to2d()

  Specified by:
    `to2d` in interface `IVecI`

### to2d

    public IVec2I to2d(IVecI projectionDir)

  Specified by:
    `to2d` in interface `IVecI`

### to2d

    public IVec2I to2d(IVecI xaxis,
                       IVecI yaxis)

  Specified by:
    `to2d` in interface `IVecI`

### to2d

    public IVec2I to2d(IVecI xaxis,
                       IVecI yaxis,
                       IVecI origin)

  Specified by:
    `to2d` in interface `IVecI`

### to4d

    public IVec4I to4d()

  Specified by:
    `to4d` in interface `IVecI`

### to4d

    public IVec4I to4d(double w)

  Specified by:
    `to4d` in interface `IVecI`

### to4d

    public IVec4I to4d(IDoubleI w)

  Specified by:
    `to4d` in interface `IVecI`

### getX

    public IDoubleI getX()

  Specified by:
    `getX` in interface `IVecI`

### getY

    public IDoubleI getY()

  Specified by:
    `getY` in interface `IVecI`

### getZ

    public IDoubleI getZ()

  Specified by:
    `getZ` in interface `IVecI`

### set

    public IPointR set(IVecI v)

  Specified by:
    `set` in interface `IVecI`

### set

    public IPointR set(double x,
                       double y,
                       double z)

  Specified by:
    `set` in interface `IVecI`

### set

    public IPointR set(IDoubleI x,
                       IDoubleI y,
                       IDoubleI z)

  Specified by:
    `set` in interface `IVecI`

### add

    public IPointR add(double x,
                       double y,
                       double z)

  Specified by:
    `add` in interface `ITransformable`
  Specified by:
    `add` in interface `IVecI`

### add

    public IPointR add(IDoubleI x,
                       IDoubleI y,
                       IDoubleI z)

  Specified by:
    `add` in interface `ITransformable`
  Specified by:
    `add` in interface `IVecI`

### add

    public IPointR add(IVecI v)

  Specified by:
    `add` in interface `ITransformable`
  Specified by:
    `add` in interface `IVecI`

### sub

    public IPointR sub(double x,
                       double y,
                       double z)

  Specified by:
    `sub` in interface `ITransformable`
  Specified by:
    `sub` in interface `IVecI`

### sub

    public IPointR sub(IDoubleI x,
                       IDoubleI y,
                       IDoubleI z)

  Specified by:
    `sub` in interface `ITransformable`
  Specified by:
    `sub` in interface `IVecI`

### sub

    public IPointR sub(IVecI v)

  Specified by:
    `sub` in interface `ITransformable`
  Specified by:
    `sub` in interface `IVecI`

### mul

    public IPointR mul(IDoubleI v)

  Specified by:
    `mul` in interface `ITransformable`
  Specified by:
    `mul` in interface `IVecI`

### mul

    public IPointR mul(double v)

  Specified by:
    `mul` in interface `ITransformable`
  Specified by:
    `mul` in interface `IVecI`

### div

    public IPointR div(IDoubleI v)

  Specified by:
    `div` in interface `ITransformable`
  Specified by:
    `div` in interface `IVecI`

### div

    public IPointR div(double v)

  Specified by:
    `div` in interface `ITransformable`
  Specified by:
    `div` in interface `IVecI`

### neg

    public IPointR neg()

  Specified by:
    `neg` in interface `ITransformable`
  Specified by:
    `neg` in interface `IVecI`

### rev

    public IPointR rev()

  Description copied from interface: `IVecI`
  alias of neg()

  Specified by:
    `rev` in interface `IVecI`

### flip

    public IPointR flip()

  Description copied from interface: `ITransformable`
  alias of neg

  Specified by:
    `flip` in interface `ITransformable`
  Specified by:
    `flip` in interface `IVecI`

### zero

    public IPointR zero()

  Description copied from interface: `IVecI`
  setting all zero

  Specified by:
    `zero` in interface `IVecI`

### add

    public IPointR add(IVecI v,
                       double f)

  scale add

  Specified by:
    `add` in interface `ITransformable`
  Specified by:
    `add` in interface `IVecI`

### add

    public IPointR add(IVecI v,
                       IDoubleI f)

  scale add

  Specified by:
    `add` in interface `ITransformable`
  Specified by:
    `add` in interface `IVecI`

### add

    public IPointR add(double f,
                       IVecI v)

  scale add alias

  Specified by:
    `add` in interface `ITransformable`
  Specified by:
    `add` in interface `IVecI`

### add

    public IPointR add(IDoubleI f,
                       IVecI v)

  scale add alias

  Specified by:
    `add` in interface `ITransformable`
  Specified by:
    `add` in interface `IVecI`

### dot

    public double dot(IVecI v)

  Description copied from interface: `IVecI`
  dot product

  Specified by:
    `dot` in interface `IVecI`

### dot

    public double dot(double vx,
                      double vy,
                      double vz)

  Description copied from interface: `IVecI`
  dot product

  Specified by:
    `dot` in interface `IVecI`

### dot

    public double dot(ISwitchE e,
                      IVecI v)

  Description copied from interface: `IVecI`
  dot product

  Specified by:
    `dot` in interface `IVecI`

### dot

    public IDoubleI dot(ISwitchR r,
                        IVecI v)

  Description copied from interface: `IVecI`
  dot product

  Specified by:
    `dot` in interface `IVecI`

### cross

    public IVecI cross(IVecI v)

  Description copied from interface: `IVecI`
  cross product, creating a new instance

  Specified by:
    `cross` in interface `IVecI`

### cross

    public IVecI cross(double vx,
                       double vy,
                       double vz)

  Description copied from interface: `IVecI`
  cross product, creating a new instance

  Specified by:
    `cross` in interface `IVecI`

### len

    public double len()

  Description copied from interface: `IVecI`
  getting length of the vector

  Specified by:
    `len` in interface `IVecI`

### len

    public double len(ISwitchE e)

  Description copied from interface: `IVecI`
  getting length of the vector

  Specified by:
    `len` in interface `IVecI`

### len

    public IDoubleI len(ISwitchR r)

  Description copied from interface: `IVecI`
  getting length of the vector

  Specified by:
    `len` in interface `IVecI`

### len2

    public double len2()

  Description copied from interface: `IVecI`
  getting squared length of the vector

  Specified by:
    `len2` in interface `IVecI`

### len2

    public double len2(ISwitchE e)

  Description copied from interface: `IVecI`
  getting squared length of the vector

  Specified by:
    `len2` in interface `IVecI`

### len2

    public IDoubleI len2(ISwitchR r)

  Description copied from interface: `IVecI`
  getting squared length of the vector

  Specified by:
    `len2` in interface `IVecI`

### len

    public IPointR len(IDoubleI l)

  Description copied from interface: `IVecI`
  setting length

  Specified by:
    `len` in interface `IVecI`

### len

    public IPointR len(double l)

  Description copied from interface: `IVecI`
  setting length

  Specified by:
    `len` in interface `IVecI`

### unit

    public IPointR unit()

  Description copied from interface: `IVecI`
  unitize

  Specified by:
    `unit` in interface `IVecI`

### dist

    public double dist(IVecI v)

  Description copied from interface: `IVecI`
  distance of two vectors

  Specified by:
    `dist` in interface `IVecI`

### dist

    public double dist(double vx,
                       double vy,
                       double vz)

  Description copied from interface: `IVecI`
  distance of two vectors

  Specified by:
    `dist` in interface `IVecI`

### dist

    public double dist(ISwitchE e,
                       IVecI v)

  Description copied from interface: `IVecI`
  distance of two vectors

  Specified by:
    `dist` in interface `IVecI`

### dist

    public IDoubleI dist(ISwitchR r,
                         IVecI v)

  Description copied from interface: `IVecI`
  distance of two vectors

  Specified by:
    `dist` in interface `IVecI`

### dist2

    public double dist2(IVecI v)

  Description copied from interface: `IVecI`
  squared distance of two vectors

  Specified by:
    `dist2` in interface `IVecI`

### dist2

    public double dist2(double vx,
                        double vy,
                        double vz)

  Description copied from interface: `IVecI`
  squared distance of two vectors

  Specified by:
    `dist2` in interface `IVecI`

### dist2

    public double dist2(ISwitchE e,
                        IVecI v)

  Description copied from interface: `IVecI`
  squared distance of two vectors

  Specified by:
    `dist2` in interface `IVecI`

### dist2

    public IDoubleI dist2(ISwitchR r,
                          IVecI v)

  Description copied from interface: `IVecI`
  squared distance of two vectors

  Specified by:
    `dist2` in interface `IVecI`

### eq

    public boolean eq(IVecI v)

  Description copied from interface: `IVecI`
  check whether location is same or not

  Specified by:
    `eq` in interface `IVecI`

### eq

    public boolean eq(double vx,
                      double vy,
                      double vz)

  Description copied from interface: `IVecI`
  check whether location is same or not

  Specified by:
    `eq` in interface `IVecI`

### eq

    public boolean eq(ISwitchE e,
                      IVecI v)

  Description copied from interface: `IVecI`
  check whether location is same or not

  Specified by:
    `eq` in interface `IVecI`

### eq

    public IBoolI eq(ISwitchR r,
                     IVecI v)

  Description copied from interface: `IVecI`
  check whether location is same or not

  Specified by:
    `eq` in interface `IVecI`

### eq

    public boolean eq(IVecI v,
                      double tolerance)

  Description copied from interface: `IVecI`
  check whether location is same or not with tolerance

  Specified by:
    `eq` in interface `IVecI`

### eq

    public boolean eq(double vx,
                      double vy,
                      double vz,
                      double tolerance)

  Description copied from interface: `IVecI`
  check whether location is same or not with tolerance

  Specified by:
    `eq` in interface `IVecI`

### eq

    public boolean eq(ISwitchE e,
                      IVecI v,
                      double tolerance)

  Description copied from interface: `IVecI`
  check whether location is same or not with tolerance

  Specified by:
    `eq` in interface `IVecI`

### eq

    public IBoolI eq(ISwitchR r,
                     IVecI v,
                     IDoubleI tolerance)

  Description copied from interface: `IVecI`
  check whether location is same or not with tolerance

  Specified by:
    `eq` in interface `IVecI`

### eqX

    public boolean eqX(IVecI v)

  Description copied from interface: `IVecI`
  check if same in X

  Specified by:
    `eqX` in interface `IVecI`

### eqY

    public boolean eqY(IVecI v)

  Description copied from interface: `IVecI`
  check if same in Y

  Specified by:
    `eqY` in interface `IVecI`

### eqZ

    public boolean eqZ(IVecI v)

  Description copied from interface: `IVecI`
  check if same in Z

  Specified by:
    `eqZ` in interface `IVecI`

### eqX

    public boolean eqX(double vx)

  Description copied from interface: `IVecI`
  check if same in X

  Specified by:
    `eqX` in interface `IVecI`

### eqY

    public boolean eqY(double vy)

  Description copied from interface: `IVecI`
  check if same in Y

  Specified by:
    `eqY` in interface `IVecI`

### eqZ

    public boolean eqZ(double vz)

  Description copied from interface: `IVecI`
  check if same in Z

  Specified by:
    `eqZ` in interface `IVecI`

### eqX

    public boolean eqX(ISwitchE e,
                       IVecI v)

  Description copied from interface: `IVecI`
  check if same in X

  Specified by:
    `eqX` in interface `IVecI`

### eqY

    public boolean eqY(ISwitchE e,
                       IVecI v)

  Description copied from interface: `IVecI`
  check if same in Y

  Specified by:
    `eqY` in interface `IVecI`

### eqZ

    public boolean eqZ(ISwitchE e,
                       IVecI v)

  Description copied from interface: `IVecI`
  check if same in Z

  Specified by:
    `eqZ` in interface `IVecI`

### eqX

    public IBoolI eqX(ISwitchR r,
                      IVecI v)

  Description copied from interface: `IVecI`
  check if same in X

  Specified by:
    `eqX` in interface `IVecI`

### eqY

    public IBoolI eqY(ISwitchR r,
                      IVecI v)

  Description copied from interface: `IVecI`
  check if same in Y

  Specified by:
    `eqY` in interface `IVecI`

### eqZ

    public IBoolI eqZ(ISwitchR r,
                      IVecI v)

  Description copied from interface: `IVecI`
  check if same in Z

  Specified by:
    `eqZ` in interface `IVecI`

### eqX

    public boolean eqX(IVecI v,
                       double tolerance)

  Description copied from interface: `IVecI`
  check if same in X with tolerance

  Specified by:
    `eqX` in interface `IVecI`

### eqY

    public boolean eqY(IVecI v,
                       double tolerance)

  Description copied from interface: `IVecI`
  check if same in Y with tolerance

  Specified by:
    `eqY` in interface `IVecI`

### eqZ

    public boolean eqZ(IVecI v,
                       double tolerance)

  Description copied from interface: `IVecI`
  check if same in Z with tolerance

  Specified by:
    `eqZ` in interface `IVecI`

### eqX

    public boolean eqX(double vx,
                       double tolerance)

  Description copied from interface: `IVecI`
  check if same in X with tolerance

  Specified by:
    `eqX` in interface `IVecI`

### eqY

    public boolean eqY(double vy,
                       double tolerance)

  Description copied from interface: `IVecI`
  check if same in Y with tolerance

  Specified by:
    `eqY` in interface `IVecI`

### eqZ

    public boolean eqZ(double vz,
                       double tolerance)

  Description copied from interface: `IVecI`
  check if same in Z with tolerance

  Specified by:
    `eqZ` in interface `IVecI`

### eqX

    public boolean eqX(ISwitchE e,
                       IVecI v,
                       double tolerance)

  Description copied from interface: `IVecI`
  check if same in X with tolerance

  Specified by:
    `eqX` in interface `IVecI`

### eqY

    public boolean eqY(ISwitchE e,
                       IVecI v,
                       double tolerance)

  Description copied from interface: `IVecI`
  check if same in Y with tolerance

  Specified by:
    `eqY` in interface `IVecI`

### eqZ

    public boolean eqZ(ISwitchE e,
                       IVecI v,
                       double tolerance)

  Description copied from interface: `IVecI`
  check if same in Z with tolerance

  Specified by:
    `eqZ` in interface `IVecI`

### eqX

    public IBoolI eqX(ISwitchR r,
                      IVecI v,
                      IDoubleI tolerance)

  Description copied from interface: `IVecI`
  check if same in X with tolerance

  Specified by:
    `eqX` in interface `IVecI`

### eqY

    public IBoolI eqY(ISwitchR r,
                      IVecI v,
                      IDoubleI tolerance)

  Description copied from interface: `IVecI`
  check if same in Y with tolerance

  Specified by:
    `eqY` in interface `IVecI`

### eqZ

    public IBoolI eqZ(ISwitchR r,
                      IVecI v,
                      IDoubleI tolerance)

  Description copied from interface: `IVecI`
  check if same in Z with tolerance

  Specified by:
    `eqZ` in interface `IVecI`

### angle

    public double angle(IVecI v)

  Description copied from interface: `IVecI`
  get angle between two vector from 0 to Pi

  Specified by:
    `angle` in interface `IVecI`

### angle

    public double angle(double vx,
                        double vy,
                        double vz)

  Description copied from interface: `IVecI`
  get angle between two vector from 0 to Pi

  Specified by:
    `angle` in interface `IVecI`

### angle

    public double angle(ISwitchE e,
                        IVecI v)

  Description copied from interface: `IVecI`
  get angle between two vector from 0 to Pi

  Specified by:
    `angle` in interface `IVecI`

### angle

    public IDoubleI angle(ISwitchR r,
                          IVecI v)

  Description copied from interface: `IVecI`
  get angle between two vector from 0 to Pi

  Specified by:
    `angle` in interface `IVecI`

### angle

    public double angle(IVecI v,
                        IVecI axis)

  Specified by:
    `angle` in interface `IVecI`
    `axis` - axis to determin sign of angle following right-handed screw rule.
  Returns:
    angle between two vector from -Pi to Pi. Sign follows right-handed screw rule along axis

### angle

    public double angle(double vx,
                        double vy,
                        double vz,
                        double axisX,
                        double axisY,
                        double axisZ)

  Specified by:
    `angle` in interface `IVecI`
  Returns:
    angle between two vector from -Pi to Pi. Sign follows right-handed screw rule along axis

### angle

    public double angle(ISwitchE e,
                        IVecI v,
                        IVecI axis)

  Specified by:
    `angle` in interface `IVecI`
    `axis` - axis to determin sign of angle following right-handed screw rule.
  Returns:
    angle between two vector from -Pi to Pi. Sign follows right-handed screw rule along axis

### angle

    public IDoubleI angle(ISwitchR r,
                          IVecI v,
                          IVecI axis)

  Specified by:
    `angle` in interface `IVecI`
    `axis` - axis to determin sign of angle following right-handed screw rule.
  Returns:
    angle between two vector from -Pi to Pi. Sign follows right-handed screw rule along axis

### rot

    public IPointR rot(IDoubleI angle)

  Description copied from interface: `ITransformable`
  rotation around z-axis and origin

  Specified by:
    `rot` in interface `ITransformable`
  Specified by:
    `rot` in interface `IVecI`

### rot

    public IPointR rot(double angle)

  Description copied from interface: `IVecI`
  rotation on XY plane

  Specified by:
    `rot` in interface `ITransformable`
  Specified by:
    `rot` in interface `IVecI`

### rot

    public IPointR rot(IVecI axis,
                       IDoubleI angle)

  Description copied from interface: `ITransformable`
  rotation around axis vector

  Specified by:
    `rot` in interface `ITransformable`
  Specified by:
    `rot` in interface `IVecI`

### rot

    public IPointR rot(IVecI axis,
                       double angle)

  Description copied from interface: `IVecI`
  rotation around axis vector

  Specified by:
    `rot` in interface `ITransformable`
  Specified by:
    `rot` in interface `IVecI`

### rot

    public IPointR rot(double axisX,
                       double axisY,
                       double axisZ,
                       double angle)

  Description copied from interface: `IVecI`
  rotation around axis vector

  Specified by:
    `rot` in interface `IVecI`

### rot

    public IPointR rot(IVecI center,
                       IVecI axis,
                       double angle)

  Description copied from interface: `IVecI`
  rotation around axis vector and center point

  Specified by:
    `rot` in interface `ITransformable`
  Specified by:
    `rot` in interface `IVecI`

### rot

    public IPointR rot(IVecI center,
                       IVecI axis,
                       IDoubleI angle)

  Description copied from interface: `ITransformable`
  rotation around axis vector and center

  Specified by:
    `rot` in interface `ITransformable`
  Specified by:
    `rot` in interface `IVecI`

### rot

    public IPointR rot(double centerX,
                       double centerY,
                       double centerZ,
                       double axisX,
                       double axisY,
                       double axisZ,
                       double angle)

  Description copied from interface: `IVecI`
  rotation around axis vector and center point

  Specified by:
    `rot` in interface `IVecI`

### rot

    public IPointR rot(IVecI axis,
                       IVecI destDir)

  rotate to destination direction vector

  Specified by:
    `rot` in interface `ITransformable`
  Specified by:
    `rot` in interface `IVecI`

### rot

    public IPointR rot(IVecI center,
                       IVecI axis,
                       IVecI destPt)

  rotate to destination point location

  Specified by:
    `rot` in interface `ITransformable`
  Specified by:
    `rot` in interface `IVecI`

### rot2

    public IPointR rot2(IDoubleI angle)

  alias of rot(IDoubleI)

  Specified by:
    `rot2` in interface `ITransformable`
  Specified by:
    `rot2` in interface `IVecI`

### rot2

    public IPointR rot2(double angle)

  alias of rot(double)

  Specified by:
    `rot2` in interface `ITransformable`
  Specified by:
    `rot2` in interface `IVecI`

### rot2

    public IPointR rot2(IVecI center,
                        double angle)

  Description copied from interface: `IVecI`
  rotation on xy-plane

  Specified by:
    `rot2` in interface `ITransformable`
  Specified by:
    `rot2` in interface `IVecI`

### rot2

    public IPointR rot2(IVecI center,
                        IDoubleI angle)

  Description copied from interface: `ITransformable`
  rotation on xy-plane around center

  Specified by:
    `rot2` in interface `ITransformable`
  Specified by:
    `rot2` in interface `IVecI`

### rot2

    public IPointR rot2(double centerX,
                        double centerY,
                        double angle)

  Description copied from interface: `IVecI`
  rotation on xy-plane

  Specified by:
    `rot2` in interface `IVecI`

### rot2

    public IPointR rot2(IVecI destDir)

  rotation on xy-plane to destination direction vector

  Specified by:
    `rot2` in interface `ITransformable`
  Specified by:
    `rot2` in interface `IVecI`

### rot2

    public IPointR rot2(IVecI center,
                        IVecI destPt)

  rotation on xy-plane to destination point location

  Specified by:
    `rot2` in interface `ITransformable`
  Specified by:
    `rot2` in interface `IVecI`

### scale

    public IPointR scale(IDoubleI f)

  alias of mul

  Specified by:
    `scale` in interface `ITransformable`
  Specified by:
    `scale` in interface `IVecI`

### scale

    public IPointR scale(double f)

  Description copied from interface: `IVecI`
  alias of mul

  Specified by:
    `scale` in interface `ITransformable`
  Specified by:
    `scale` in interface `IVecI`

### scale

    public IPointR scale(IVecI center,
                         IDoubleI f)

  Description copied from interface: `IVecI`
  scale from a center

  Specified by:
    `scale` in interface `ITransformable`
  Specified by:
    `scale` in interface `IVecI`

### scale

    public IPointR scale(IVecI center,
                         double f)

  Description copied from interface: `IVecI`
  scale from a center

  Specified by:
    `scale` in interface `ITransformable`
  Specified by:
    `scale` in interface `IVecI`

### scale

    public IPointR scale(double centerX,
                         double centerY,
                         double centerZ,
                         double f)

  Description copied from interface: `IVecI`
  scale from a center

  Specified by:
    `scale` in interface `IVecI`

### scale1d

    public IPointR scale1d(IVecI axis,
                           double f)

  scale only in 1 direction

  Specified by:
    `scale1d` in interface `ITransformable`
  Specified by:
    `scale1d` in interface `IVecI`

### scale1d

    public IPointR scale1d(IVecI axis,
                           IDoubleI f)

  Description copied from interface: `IVecI`
  scale only in 1 direction

  Specified by:
    `scale1d` in interface `ITransformable`
  Specified by:
    `scale1d` in interface `IVecI`

### scale1d

    public IPointR scale1d(double axisX,
                           double axisY,
                           double axisZ,
                           double f)

  Description copied from interface: `IVecI`
  scale only in 1 direction

  Specified by:
    `scale1d` in interface `IVecI`

### scale1d

    public IPointR scale1d(IVecI center,
                           IVecI axis,
                           double f)

  Description copied from interface: `IVecI`
  scale only in 1 direction from a center

  Specified by:
    `scale1d` in interface `ITransformable`
  Specified by:
    `scale1d` in interface `IVecI`

### scale1d

    public IPointR scale1d(IVecI center,
                           IVecI axis,
                           IDoubleI f)

  Description copied from interface: `IVecI`
  scale only in 1 direction from a center

  Specified by:
    `scale1d` in interface `ITransformable`
  Specified by:
    `scale1d` in interface `IVecI`

### scale1d

    public IPointR scale1d(double centerX,
                           double centerY,
                           double centerZ,
                           double axisX,
                           double axisY,
                           double axisZ,
                           double f)

  Description copied from interface: `IVecI`
  scale only in 1 direction from a center

  Specified by:
    `scale1d` in interface `IVecI`

### ref

    public IPointR ref(IVecI planeDir)

  reflect (mirror) 3 dimensionally to the other side of the plane

  Specified by:
    `ref` in interface `ITransformable`
  Specified by:
    `ref` in interface `IVecI`

### ref

    public IPointR ref(double planeX,
                       double planeY,
                       double planeZ)

  Description copied from interface: `IVecI`
  reflect(mirror) 3 dimensionally to the other side of the plane

  Specified by:
    `ref` in interface `IVecI`

### ref

    public IPointR ref(IVecI center,
                       IVecI planeDir)

  Description copied from interface: `IVecI`
  reflect(mirror) 3 dimensionally to the other side of the plane

  Specified by:
    `ref` in interface `ITransformable`
  Specified by:
    `ref` in interface `IVecI`

### ref

    public IPointR ref(double centerX,
                       double centerY,
                       double centerZ,
                       double planeX,
                       double planeY,
                       double planeZ)

  Description copied from interface: `IVecI`
  reflect(mirror) 3 dimensionally to the other side of the plane

  Specified by:
    `ref` in interface `IVecI`

### mirror

    public IPointR mirror(IVecI planeDir)

  reflect (mirror) 3 dimensionally to the other side of the plane

  Specified by:
    `mirror` in interface `ITransformable`
  Specified by:
    `mirror` in interface `IVecI`

### mirror

    public IPointR mirror(double planeX,
                          double planeY,
                          double planeZ)

  Description copied from interface: `IVecI`
  alias of ref

  Specified by:
    `mirror` in interface `IVecI`

### mirror

    public IPointR mirror(IVecI center,
                          IVecI planeDir)

  Description copied from interface: `IVecI`
  alias of ref

  Specified by:
    `mirror` in interface `ITransformable`
  Specified by:
    `mirror` in interface `IVecI`

### mirror

    public IPointR mirror(double centerX,
                          double centerY,
                          double centerZ,
                          double planeX,
                          double planeY,
                          double planeZ)

  Description copied from interface: `IVecI`
  alias of ref

  Specified by:
    `mirror` in interface `IVecI`

### shear

    public IPointR shear(double sxy,
                         double syx,
                         double syz,
                         double szy,
                         double szx,
                         double sxz)

  shear operation

  Specified by:
    `shear` in interface `ITransformable`
  Specified by:
    `shear` in interface `IVecI`

### shear

    public IPointR shear(IDoubleI sxy,
                         IDoubleI syx,
                         IDoubleI syz,
                         IDoubleI szy,
                         IDoubleI szx,
                         IDoubleI sxz)

  Description copied from interface: `IVecI`
  shear operation

  Specified by:
    `shear` in interface `ITransformable`
  Specified by:
    `shear` in interface `IVecI`

### shear

    public IPointR shear(IVecI center,
                         double sxy,
                         double syx,
                         double syz,
                         double szy,
                         double szx,
                         double sxz)

  Description copied from interface: `IVecI`
  shear operation

  Specified by:
    `shear` in interface `ITransformable`
  Specified by:
    `shear` in interface `IVecI`

### shear

    public IPointR shear(IVecI center,
                         IDoubleI sxy,
                         IDoubleI syx,
                         IDoubleI syz,
                         IDoubleI szy,
                         IDoubleI szx,
                         IDoubleI sxz)

  Description copied from interface: `IVecI`
  shear operation

  Specified by:
    `shear` in interface `ITransformable`
  Specified by:
    `shear` in interface `IVecI`

### shearXY

    public IPointR shearXY(double sxy,
                           double syx)

  Description copied from interface: `IVecI`
  shear operation on XY

  Specified by:
    `shearXY` in interface `ITransformable`
  Specified by:
    `shearXY` in interface `IVecI`

### shearXY

    public IPointR shearXY(IDoubleI sxy,
                           IDoubleI syx)

  Description copied from interface: `IVecI`
  shear operation on XY

  Specified by:
    `shearXY` in interface `ITransformable`
  Specified by:
    `shearXY` in interface `IVecI`

### shearXY

    public IPointR shearXY(IVecI center,
                           double sxy,
                           double syx)

  Description copied from interface: `IVecI`
  shear operation on XY

  Specified by:
    `shearXY` in interface `ITransformable`
  Specified by:
    `shearXY` in interface `IVecI`

### shearXY

    public IPointR shearXY(IVecI center,
                           IDoubleI sxy,
                           IDoubleI syx)

  Description copied from interface: `IVecI`
  shear operation on XY

  Specified by:
    `shearXY` in interface `ITransformable`
  Specified by:
    `shearXY` in interface `IVecI`

### shearYZ

    public IPointR shearYZ(double syz,
                           double szy)

  Description copied from interface: `IVecI`
  shear operation on YZ

  Specified by:
    `shearYZ` in interface `ITransformable`
  Specified by:
    `shearYZ` in interface `IVecI`

### shearYZ

    public IPointR shearYZ(IDoubleI syz,
                           IDoubleI szy)

  Description copied from interface: `IVecI`
  shear operation on YZ

  Specified by:
    `shearYZ` in interface `ITransformable`
  Specified by:
    `shearYZ` in interface `IVecI`

### shearYZ

    public IPointR shearYZ(IVecI center,
                           double syz,
                           double szy)

  Description copied from interface: `IVecI`
  shear operation on YZ

  Specified by:
    `shearYZ` in interface `ITransformable`
  Specified by:
    `shearYZ` in interface `IVecI`

### shearYZ

    public IPointR shearYZ(IVecI center,
                           IDoubleI syz,
                           IDoubleI szy)

  Description copied from interface: `IVecI`
  shear operation on YZ

  Specified by:
    `shearYZ` in interface `ITransformable`
  Specified by:
    `shearYZ` in interface `IVecI`

### shearZX

    public IPointR shearZX(double szx,
                           double sxz)

  Description copied from interface: `IVecI`
  shear operation on ZX

  Specified by:
    `shearZX` in interface `ITransformable`
  Specified by:
    `shearZX` in interface `IVecI`

### shearZX

    public IPointR shearZX(IDoubleI szx,
                           IDoubleI sxz)

  Description copied from interface: `IVecI`
  shear operation on ZX

  Specified by:
    `shearZX` in interface `ITransformable`
  Specified by:
    `shearZX` in interface `IVecI`

### shearZX

    public IPointR shearZX(IVecI center,
                           double szx,
                           double sxz)

  Description copied from interface: `IVecI`
  shear operation on ZX

  Specified by:
    `shearZX` in interface `ITransformable`
  Specified by:
    `shearZX` in interface `IVecI`

### shearZX

    public IPointR shearZX(IVecI center,
                           IDoubleI szx,
                           IDoubleI sxz)

  Description copied from interface: `IVecI`
  shear operation on ZX

  Specified by:
    `shearZX` in interface `ITransformable`
  Specified by:
    `shearZX` in interface `IVecI`

### translate

    public IPointR translate(double x,
                             double y,
                             double z)

  translate is alias of add()

  Specified by:
    `translate` in interface `ITransformable`
  Specified by:
    `translate` in interface `IVecI`

### translate

    public IPointR translate(IDoubleI x,
                             IDoubleI y,
                             IDoubleI z)

  Description copied from interface: `IVecI`
  alias of add()

  Specified by:
    `translate` in interface `ITransformable`
  Specified by:
    `translate` in interface `IVecI`

### translate

    public IPointR translate(IVecI v)

  Description copied from interface: `IVecI`
  alias of add()

  Specified by:
    `translate` in interface `ITransformable`
  Specified by:
    `translate` in interface `IVecI`

### transform

    public IPointR transform(IMatrix3I mat)

  Description copied from interface: `IVecI`
  transform with a transformation matrix

  Specified by:
    `transform` in interface `ITransformable`
  Specified by:
    `transform` in interface `IVecI`

### transform

    public IPointR transform(IMatrix4I mat)

  Description copied from interface: `IVecI`
  transform with a transformation matrix

  Specified by:
    `transform` in interface `ITransformable`
  Specified by:
    `transform` in interface `IVecI`

### transform

    public IPointR transform(IVecI xvec,
                             IVecI yvec,
                             IVecI zvec)

  Description copied from interface: `IVecI`
  transform with a transformation vectors

  Specified by:
    `transform` in interface `ITransformable`
  Specified by:
    `transform` in interface `IVecI`

### transform

    public IPointR transform(IVecI xvec,
                             IVecI yvec,
                             IVecI zvec,
                             IVecI translate)

  Description copied from interface: `IVecI`
  transform with a transformation vectors

  Specified by:
    `transform` in interface `ITransformable`
  Specified by:
    `transform` in interface `IVecI`

### mv

    public IPointR mv(double x,
                      double y,
                      double z)

  mv() is alias of add()

  Specified by:
    `mv` in interface `ITransformable`
  Specified by:
    `mv` in interface `IVecI`

### mv

    public IPointR mv(IDoubleI x,
                      IDoubleI y,
                      IDoubleI z)

  Description copied from interface: `IVecI`
  mv() is alias of add()

  Specified by:
    `mv` in interface `ITransformable`
  Specified by:
    `mv` in interface `IVecI`

### mv

    public IPointR mv(IVecI v)

  Description copied from interface: `IVecI`
  mv() is alias of add()

  Specified by:
    `mv` in interface `ITransformable`
  Specified by:
    `mv` in interface `IVecI`

### cp

    public IPointR cp()

  cp() is alias of dup()

  Specified by:
    `cp` in interface `ITransformable`
  Specified by:
    `cp` in interface `IVecI`
  Overrides:
    `cp` in class `IObject`

### cp

    public IPointR cp(double x,
                      double y,
                      double z)

  cp() is alias of dup().add()

  Specified by:
    `cp` in interface `ITransformable`
  Specified by:
    `cp` in interface `IVecI`

### cp

    public IPointR cp(IDoubleI x,
                      IDoubleI y,
                      IDoubleI z)

  Description copied from interface: `IVecI`
  cp() is alias of dup().add()

  Specified by:
    `cp` in interface `ITransformable`
  Specified by:
    `cp` in interface `IVecI`

### cp

    public IPointR cp(IVecI v)

  Description copied from interface: `IVecI`
  cp() is alias of dup().add()

  Specified by:
    `cp` in interface `ITransformable`
  Specified by:
    `cp` in interface `IVecI`

### dif

    public IVecI dif(IVecI v)

  Description copied from interface: `IVecI`
  create a new instance of difference

  Specified by:
    `dif` in interface `IVecI`

### dif

    public IVecI dif(double vx,
                     double vy,
                     double vz)

  Description copied from interface: `IVecI`
  create a new instance of difference

  Specified by:
    `dif` in interface `IVecI`

### diff

    public IVecI diff(IVecI v)

  Description copied from interface: `IVecI`
  alias of dif

  Specified by:
    `diff` in interface `IVecI`

### diff

    public IVecI diff(double vx,
                      double vy,
                      double vz)

  Description copied from interface: `IVecI`
  alias of dif

  Specified by:
    `diff` in interface `IVecI`

### mid

    public IVecI mid(IVecI v)

  Description copied from interface: `IVecI`
  create a new instance of midpoint

  Specified by:
    `mid` in interface `IVecI`

### mid

    public IVecI mid(double vx,
                     double vy,
                     double vz)

  Description copied from interface: `IVecI`
  create a new instance of midpoint

  Specified by:
    `mid` in interface `IVecI`

### sum

    public IVecI sum(IVecI v)

  Description copied from interface: `IVecI`
  create a new instance of total summation

  Specified by:
    `sum` in interface `IVecI`

### sum

    public IVecI sum(double vx,
                     double vy,
                     double vz)

  Description copied from interface: `IVecI`
  create a new instance of total summation

  Specified by:
    `sum` in interface `IVecI`

### sum

    public IVecI sum(IVecI... v)

  Description copied from interface: `IVecI`
  create a new instance of total summation

  Specified by:
    `sum` in interface `IVecI`

### bisect

    public IVecI bisect(IVecI v)

  Description copied from interface: `IVecI`
  create a new instance of bisector

  Specified by:
    `bisect` in interface `IVecI`

### bisect

    public IVecI bisect(double vx,
                        double vy,
                        double vz)

  Description copied from interface: `IVecI`
  create a new instance of bisector

  Specified by:
    `bisect` in interface `IVecI`

### sum

    public IVecI sum(IVecI v2,
                     double w1,
                     double w2)

  weighted sum.

  Specified by:
    `sum` in interface `IVecI`
  Returns:
    IVecI

### sum

    public IVecI sum(IVecI v2,
                     double w2)

  Description copied from interface: `IVecI`
  create a new instance of weighted sum

  Specified by:
    `sum` in interface `IVecI`

### sum

    public IVecI sum(IVecI v2,
                     IDoubleI w1,
                     IDoubleI w2)

  Description copied from interface: `IVecI`
  create a new instance of weighted sum

  Specified by:
    `sum` in interface `IVecI`

### sum

    public IVecI sum(IVecI v2,
                     IDoubleI w2)

  Description copied from interface: `IVecI`
  create a new instance of weighted sum

  Specified by:
    `sum` in interface `IVecI`

### nml

    public IVecI nml(IVecI v)

  alias of cross. (not unitized ... ?) returns IVecI.

  Specified by:
    `nml` in interface `IVecI`

### nml

    public IVecI nml(double vx,
                     double vy,
                     double vz)

  Description copied from interface: `IVecI`
  alias of cross

  Specified by:
    `nml` in interface `IVecI`

### nml

    public IVecI nml(IVecI pt1,
                     IVecI pt2)

  create normal vector from 3 points of self, pt1 and pt2

  Specified by:
    `nml` in interface `IVecI`

### nml

    public IVecI nml(double vx1,
                     double vy1,
                     double vz1,
                     double vx2,
                     double vy2,
                     double vz2)

  Description copied from interface: `IVecI`
  create normal vector from 3 points of self, pt1 and pt2

  Specified by:
    `nml` in interface `IVecI`

### isValid

    public boolean isValid()

  checking x, y, and z is valid number (not Infinite, nor NaN).

  Specified by:
    `isValid` in interface `IVecI`
  Overrides:
    `isValid` in class `IObject`

### setSize

    public IPointR setSize(double sz)

  set size of dot in graphic

### size

    public IPointR size(double sz)

### getSize

    public double getSize()

### size

    public double size()

### name

    public IPointR name(java.lang.String nm)

  Overrides:
    `name` in class `IObject`

### layer

    public IPointR layer(ILayer l)

  Description copied from class: `IObject`
  Set layer by ILayer object

  Overrides:
    `layer` in class `IObject`

### hide

    public IPointR hide()

  Overrides:
    `hide` in class `IObject`

### show

    public IPointR show()

  Overrides:
    `show` in class `IObject`

### clr

    public IPointR clr(IColor c)

  Overrides:
    `clr` in class `IObject`

### clr

    public IPointR clr(IColor c,
                       int alpha)

  Description copied from class: `IObject`
  to set color, with alpha value overwritten

  Overrides:
    `clr` in class `IObject`

### clr

    public IPointR clr(IColor c,
                       float alpha)

  Description copied from class: `IObject`
  to set color, with alpha value overwritten

  Overrides:
    `clr` in class `IObject`

### clr

    public IPointR clr(IColor c,
                       double alpha)

  Description copied from class: `IObject`
  to set color, with alpha value overwritten

  Overrides:
    `clr` in class `IObject`

### clr

    public IPointR clr(java.awt.Color c)

  Overrides:
    `clr` in class `IObject`

### clr

    public IPointR clr(java.awt.Color c,
                       int alpha)

  Overrides:
    `clr` in class `IObject`

### clr

    public IPointR clr(java.awt.Color c,
                       float alpha)

  Overrides:
    `clr` in class `IObject`

### clr

    public IPointR clr(java.awt.Color c,
                       double alpha)

  Overrides:
    `clr` in class `IObject`

### clr

    public IPointR clr(int gray)

  Overrides:
    `clr` in class `IObject`

### clr

    public IPointR clr(float fgray)

  Overrides:
    `clr` in class `IObject`

### clr

    public IPointR clr(double dgray)

  Overrides:
    `clr` in class `IObject`

### clr

    public IPointR clr(int gray,
                       int alpha)

  Overrides:
    `clr` in class `IObject`

### clr

    public IPointR clr(float fgray,
                       float falpha)

  Overrides:
    `clr` in class `IObject`

### clr

    public IPointR clr(double dgray,
                       double dalpha)

  Overrides:
    `clr` in class `IObject`

### clr

    public IPointR clr(int r,
                       int g,
                       int b)

  Overrides:
    `clr` in class `IObject`

### clr

    public IPointR clr(float fr,
                       float fg,
                       float fb)

  Overrides:
    `clr` in class `IObject`

### clr

    public IPointR clr(double dr,
                       double dg,
                       double db)

  Overrides:
    `clr` in class `IObject`

### clr

    public IPointR clr(int r,
                       int g,
                       int b,
                       int a)

  Overrides:
    `clr` in class `IObject`

### clr

    public IPointR clr(float fr,
                       float fg,
                       float fb,
                       float fa)

  Overrides:
    `clr` in class `IObject`

### clr

    public IPointR clr(double dr,
                       double dg,
                       double db,
                       double da)

  Overrides:
    `clr` in class `IObject`

### hsb

    public IPointR hsb(float h,
                       float s,
                       float b,
                       float a)

  Overrides:
    `hsb` in class `IObject`

### hsb

    public IPointR hsb(double h,
                       double s,
                       double b,
                       double a)

  Overrides:
    `hsb` in class `IObject`

### hsb

    public IPointR hsb(float h,
                       float s,
                       float b)

  Overrides:
    `hsb` in class `IObject`

### hsb

    public IPointR hsb(double h,
                       double s,
                       double b)

  Overrides:
    `hsb` in class `IObject`

### setColor

    public IPointR setColor(java.awt.Color c)

  Overrides:
    `setColor` in class `IObject`

### setColor

    public IPointR setColor(java.awt.Color c,
                            int alpha)

  Overrides:
    `setColor` in class `IObject`

### setColor

    public IPointR setColor(int gray)

  Overrides:
    `setColor` in class `IObject`

### setColor

    public IPointR setColor(float fgray)

  Overrides:
    `setColor` in class `IObject`

### setColor

    public IPointR setColor(double dgray)

  Overrides:
    `setColor` in class `IObject`

### setColor

    public IPointR setColor(int gray,
                            int alpha)

  Overrides:
    `setColor` in class `IObject`

### setColor

    public IPointR setColor(float fgray,
                            float falpha)

  Overrides:
    `setColor` in class `IObject`

### setColor

    public IPointR setColor(double dgray,
                            double dalpha)

  Overrides:
    `setColor` in class `IObject`

### setColor

    public IPointR setColor(int r,
                            int g,
                            int b)

  Overrides:
    `setColor` in class `IObject`

### setColor

    public IPointR setColor(float fr,
                            float fg,
                            float fb)

  Overrides:
    `setColor` in class `IObject`

### setColor

    public IPointR setColor(double dr,
                            double dg,
                            double db)

  Overrides:
    `setColor` in class `IObject`

### setColor

    public IPointR setColor(int r,
                            int g,
                            int b,
                            int a)

  Overrides:
    `setColor` in class `IObject`

### setColor

    public IPointR setColor(float fr,
                            float fg,
                            float fb,
                            float fa)

  Overrides:
    `setColor` in class `IObject`

### setColor

    public IPointR setColor(double dr,
                            double dg,
                            double db,
                            double da)

  Overrides:
    `setColor` in class `IObject`

### setHSBColor

    public IPointR setHSBColor(float h,
                               float s,
                               float b,
                               float a)

  Overrides:
    `setHSBColor` in class `IObject`

### setHSBColor

    public IPointR setHSBColor(double h,
                               double s,
                               double b,
                               double a)

  Overrides:
    `setHSBColor` in class `IObject`

### setHSBColor

    public IPointR setHSBColor(float h,
                               float s,
                               float b)

  Overrides:
    `setHSBColor` in class `IObject`

### setHSBColor

    public IPointR setHSBColor(double h,
                               double s,
                               double b)

  Overrides:
    `setHSBColor` in class `IObject`

### weight

    public IPointR weight(double w)

  Overrides:
    `weight` in class `IObject`

### weight

    public IPointR weight(float w)

  Overrides:
    `weight` in class `IObject`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD